routes/web.php
<?php

use App\Http\Controllers\Admin\BusinessController;
use App\Http\Controllers\Admin\CategoryController;
use App\Http\Controllers\Admin\HomeController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->name('home');

//auth routes
Route::group([],function(){
Route::get('/login',[LoginController::class,'login_form'])->name('login');
Route::post('/login',[LoginController::class,'login'])->name('login.store');
Route::post('/logout',[LoginController::class,'logout'])->name('logout');


});

// auth required routes
Route::group(['middleware'=>'auth'],function(){
    //admin routes
    Route::group(['middleware'=>'is_Admin','prefix'=>'admin'],function(){
        Route::get('/',[HomeController::class,'index'])->name('admin.home');

        Route::resource('/users',UserController::class);
        Route::resource('/categories',CategoryController::class);
        Route::resource('/businesses',BusinessController::class);
    });

});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    const ADMIN=2;
    const USER=1;
    
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\CreateUserRequest;
use App\Http\Requests\UpdateUserRequest;

use App\Models\User as ModelsUser;
use DeepCopy\Filter\Filter;
use Illuminate\Foundation\Auth\User;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Auth;

class UserController extends Controller
{
    //

  /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(ModelsUser $user, Request $request)
    {

        // $users = $user;
        //  if ($request->query('role') && $request->query('role') != 'none') {
        //     $users = $users->where('role', $request->query('role'));
        // }
        $users = User::orderBy('created_at', 'desc')->paginate(8);
        $name = 'users';
        $data = $users;

        return view('admin.users.index', compact('users', 'name', 'data'));
    }

      /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */


    public function create(Request $request)
    {

        return view('admin.users.create');
    }


      /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */


    public function store(CreateUserRequest $request)
    {

       // return $request;


        $user = new User();
        $user->name    = $request->input('name');
        $user->email    = $request->input('email');
        $user->password = bcrypt($request->password);
        $user->role     = $request->input('role');
        $user->save();

        return redirect()->route('users.index')->with('message', 'User created successfully');

    }



      /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(ModelsUser $user)
    {

        $name = 'users';

        return view('admin.users.update', compact('user', 'name'));
    }





       /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateUserRequest $request, User $user)
    {

       // return($request);
        $user->save();
        return redirect()->route('users.index')->with('message', 'User info updated');
    }




     /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(ModelsUser $user)
    {



        if ($user->role == 2) {
            $user->delete();
            return redirect()->back()->with('message', 'Admin deleted successfully');
        } elseif ($user->role == 1) {
            $user->delete();
            return redirect()->back()->with('message', 'User deleted successfully');
        }else{
            $user->delete();
            return redirect()->back()->with('message', 'User deleted successfully');

        }
    }



}

resources/views/admin/users/create.blade.php
@extends('layouts.resources.create')

@section('form')
@include('_includes.message')

<form class="d-flex flex-column " method="POST" action="{{route('users.store')}}">
    @csrf
    <div class="form-group">
        <label for="exampleFormControlInput1">User name</label>
        <input type="name" name="name"  class="form-control" id="exampleFormControlInput1" placeholder="example">
      </div>

    <div class="form-group">
      <label for="exampleFormControlInput1">Email address</label>
      <input type="email" name="email" class="form-control" id="exampleFormControlInput1" placeholder="name@example.com">
    </div>

    <div class="form-group">
        <label for="exampleInputPassword1">Password</label>
        <input type="password" name="password" class="form-control" id="exampleInputPassword1">
      </div>

    <div class="form-group">
      <label for="exampleFormControlSelect1">Select Role</label>
      <select class="form-control" name="role" id="role">
        <option selected >-- Choose --</option>
        <option value="1" >User</option>
        <option value="2">Admin</option>
      </select>
    </div>

    <button type="submit" class="btn btn-primary align-self-end">Submit</button>

</form>
@endsection

resources/views/admin/users/index.blade.php
@extends('layouts.resources.index')


@section('header')
<nav class="navbar d-flex justify-content-between navbar-expand-lg navbar-light bg-light  align-content-justify-end">
    <a class="navbar-brand " href="#">User Management</a>

        <a type="submit" class="btn btn-primary   align-self-end"  href="{{route('users.create')}}">Add User</a>

</nav>
@endsection
@section('table-header')
        <tr>
        <th scope="col">#</th>
        <th scope="col">Name</th>
        <th scope="col">Email</th>
        <th scope="col">User Role</th>
        <th scope="col">Joined</th>
        <th scope="col">Options</th>
        </tr>
@endsection



@section('table-body')
            @foreach ($data as $item)
           <tr>
                <td>{{$item->id}}</td>
             <td>{{$item->name}}</td>
             <td>{{$item->email}}</td>
            <td>{{$item->role}}</td>
           <td>{{$item->created_at}}</td>
           <td>
            <form method="POST"
            action="{{route('users.edit',$item)}}">
             @csrf
             @method('GET')
             <button type="submit" class="btn btn-success   align-self-end">Edit</button>
            </form>

                <form method="POST"
                action="{{route('users.destroy',$item->id)}}">
                 @csrf
                 @method('DELETE')
                <button type="submit" class="btn btn-danger   align-self-end">Delete</button>
            </form>


           </td>

            </tr>


            @endforeach

@endsection

resources/views/admin/users/update.blade.php
@extends('layouts.resources.update')

@section('form')
@include('_includes.message')
@php

@endphp
 <form class="d-flex flex-column "  method="POST" action="{{route('users.update', $user->id)}}">
    @csrf
    @method('PUT')
    <div class="form-group">
        <label for="exampleFormControlInput1">User name</label>
        <input type="name" name="name"  class="form-control" id="exampleFormControlInput1" placeholder="{{$user->name}}">

      </div>

    <div class="form-group">
      <label for="exampleFormControlInput1">Email address</label>
      <input type="email" name="email" class="form-control" id="disabledTextInput"  disabled placeholder="{{$user->email}}"
        value="{{$user->email}}">
     </div>



    <div class="form-group">
      <label for="exampleFormControlSelect1">Select Role</label>
      <select class="form-control" name="role" id="role">
        <option selected >-- Choose --</option>
        <option value="1" >User</option>
        <option value="2">Admin</option>
      </select>
    </div>

    <button type="submit" class="btn btn-primary align-self-end">Update</button>

</form>
 @endsection